import processing.sound.*;

//Variablen Hauptmenu
//Audios Hauptmenu
SoundFile BGM;
SoundFile BGM_game;
SoundFile clicksound;
SoundFile lasersound;

//cursor ja/nein
boolean cursor = true;

//click-delay
int delay_timer = 0;

//sound delay
int sound_delay_timer = 0;

//Schrift Hauptmenu
PFont ERAS;
PFont ERAS_2;

//Musik starten JA/NEIN
boolean start_music = true;

//Variablen Raumschiff-Auswahl
PImage[] Spaceships = new PImage[3];
int ShipNumber = 0;

int SelectedShipNumber = 0;


//Variablen Spiel
PImage Background;

// BIld-Arrays gifs
PImage[] Asteroid1 = new PImage[20];
PImage[] Explosion = new PImage[23];

//Zustände Ansichten
boolean game_started = false;
boolean main_menu = true;
boolean ship_selection = false;
boolean start_music_game = true;
boolean game_paused = false;
boolean help_menu = false;
boolean GameOver = false;

//Maus Bewegung im Hauptmenu
boolean game_mouse_movement = true;

//Variablen Punktesystem
int score = 0;
int tempscore = 0;
int level = 0;

//Geschwindigkeit des Hintergrundbildes speichern im Pausemenu
int tempYspeed = 0;
int tempYSpeed = 0;


//Schriftart
PFont Stencil;

//Variablem Explosion
boolean explosion = false;
int ETimer = 21;
int i = 0;

// Variablen Laser-Schuss
int LaserX = 0;
int LaserY = 700;
boolean shoot = false;

// Variablen Asteroid 1
boolean moving = true;
float x = 600;
int y = -500;
int YSpeed = 20;

// Variablen Hintergrund
int XBackground = 0;
int YBackground = 0;
int YBackground2 = -800;
int Yspeed = 10;

//Farbe Fadenkreuz
color crosshair = color(255, 0, 0);
int Xcrosshair = 0;
int Ycrosshair = 0;

//Variablem Spielschluss

int xEndPos = 0;
int yEndPos = 0;
boolean ship_visible = true;
boolean crosshair_visible = true;
boolean crash = false;
boolean noCrashEnd = false;

//Variablen GameOver
int opacity = 60;

//Variablen Help Menu
PImage[] Tutorial = new PImage[6];
String[] Tutorial_text = new String[6];
int page_number = 0;


void setup() {

  //Einstellungen Programm
  size(1200, 800);
  Background = loadImage("images/Background.jpg");
  frameRate(200);


  //Raumschiff-Auswahl Bild-Import
  Spaceships[0] = loadImage("images/Spaceship1.png");
  Spaceships[1] = loadImage("images/Spaceship2.png");
  Spaceships[2] = loadImage("images/Spaceship3.png");


  //Asteroid 1 Bild-Import
  smooth();
  Asteroid1[0] = loadImage( "images/1_1.gif" );
  Asteroid1[1] = loadImage( "images/1_2.gif" );
  Asteroid1[2] = loadImage( "images/1_3.gif" );
  Asteroid1[3] = loadImage( "images/1_4.gif" );
  Asteroid1[4] = loadImage( "images/1_5.gif" );
  Asteroid1[5] = loadImage( "images/1_6.gif" );
  Asteroid1[6] = loadImage( "images/1_7.gif" );
  Asteroid1[7] = loadImage( "images/1_8.gif" );
  Asteroid1[8] = loadImage( "images/1_9.gif" );
  Asteroid1[9] = loadImage( "images/1_10.gif" );
  Asteroid1[10] = loadImage( "images/1_11.gif" );
  Asteroid1[11] = loadImage( "images/1_12.gif" );
  Asteroid1[12] = loadImage( "images/1_13.gif" );
  Asteroid1[13] = loadImage( "images/1_14.gif" );
  Asteroid1[14] = loadImage( "images/1_15.gif" );
  Asteroid1[15] = loadImage( "images/1_16.gif" );
  Asteroid1[16] = loadImage( "images/1_17.gif" );
  Asteroid1[17] = loadImage( "images/1_18.gif" );
  Asteroid1[18] = loadImage( "images/1_19.gif" );
  Asteroid1[19] = loadImage( "images/1_20.gif" );

  //Explosion Bild-Import
  Explosion[0] = loadImage( "images/E1.gif" );
  Explosion[1] = loadImage( "images/E2.gif" );
  Explosion[2] = loadImage( "images/E3.gif" );
  Explosion[3] = loadImage( "images/E4.gif" );
  Explosion[4] = loadImage( "images/E5.gif" );
  Explosion[5] = loadImage( "images/E6.gif" );
  Explosion[6] = loadImage( "images/E7.gif" );
  Explosion[7] = loadImage( "images/E8.gif" );
  Explosion[8] = loadImage( "images/E9.gif" );
  Explosion[9] = loadImage( "images/E10.gif" );
  Explosion[10] = loadImage( "images/E11.gif" );
  Explosion[11] = loadImage( "images/E12.gif" );
  Explosion[12] = loadImage( "images/E13.gif" );
  Explosion[13] = loadImage( "images/E14.gif" );
  Explosion[14] = loadImage( "images/E15.gif" );
  Explosion[15] = loadImage( "images/E16.gif" );
  Explosion[16] = loadImage( "images/E17.gif" );
  Explosion[17] = loadImage( "images/E18.gif" );
  Explosion[18] = loadImage( "images/E19.gif" );
  Explosion[19] = loadImage( "images/E20.gif" );
  Explosion[20] = loadImage( "images/E21.gif" );
  Explosion[21] = loadImage( "images/E22.gif" );
  Explosion[22] = loadImage( "images/E23.gif" );

  //Tutorial-Bilder Import
  Tutorial[0] = loadImage( "images/Tutorial_1.PNG" );
  Tutorial[1] = loadImage( "images/Tutorial_2.PNG" );
  Tutorial[2] = loadImage( "images/Tutorial_3.PNG" );
  Tutorial[3] = loadImage( "images/Tutorial_3.PNG" );
  Tutorial[4] = loadImage( "images/Tutorial_4.PNG" );
  Tutorial[5] = loadImage( "images/Tutorial_5.PNG" );
  
  //Texte Tutorial
  Tutorial_text[0] = "Bewegen Sie die Maus horizontal, um das Raumschiff horizontal zu verschieben.";
  Tutorial_text[1] = "Asteroiden werden zerstört, indem man sie mit der Maus anklickt.";
  Tutorial_text[2] = "Mit jedem abgeschossenen Asteroid erhöht sich Ihr Score um 1.";
  Tutorial_text[3] = "Ihr Level erhöht sich mit jedem 10. abgeschossenen Asteroid. Je höher das Level, desto schneller die Asteroiden.";
  Tutorial_text[4] = "Drücken Sie die Taste 'P' um das Spiel zu pausieren.";
  Tutorial_text[5] = "Wenn ein Asteroid das Raumschiff trifft oder aus dem Bild fliegt endet das Spiel.";

  //Schriften-Import
  Stencil = createFont("Stencil", 100);
  ERAS = createFont("Eras Demi ITC", 40);
  ERAS_2 = createFont("Eras Demi ITC", 20);


  //Import sounds
  BGM = new SoundFile(this, "Sounds/InterstellarMainTheme.mp3"); //Hintergrund musik Hauptmenu
  BGM_game =  new SoundFile(this, "Sounds/NoTimeForCaution.wav"); //Hintergrund musik Spiel
  clicksound = new SoundFile(this, "Sounds/Interface_klick.wav"); //Knopfdruck Ton
  lasersound = new SoundFile(this, "Sounds/beam8.wav"); //Laserschuss Ton
}

void draw() {

  //cursor ja/nein
  if (cursor == true) {
    cursor();
  } else {
    noCursor();
  }
  
  //Verzögerung nach Knopfdrücken -> Timer
  if (delay_timer > 0) {
    delay_timer--;
  }
  
    //Verzögerung nach Tönen -> Timer
  if (sound_delay_timer > 0) {
    sound_delay_timer--;
  }
  
  //Zustände Überprüfen
  if (main_menu == true) {
    MainMenu();
  } 
  
  else if (help_menu == true) {
    help_menu();
  } 
  
  else if (game_started == true) {
    game();
  } 
  
  else if (ship_selection == true) {
    spaceship_selection();
  } 
  
  else if (GameOver == true) {
    game_over();
  }

  if (game_paused == true) {
    GamePaused();
  }
}


void MainMenu() {
  
  if(start_music == true){
   playmusic_mainmenu();
   }
   
  //Hintergrundbild Hauptmenu
  background(0);
  imageMode(CORNER);
  image(Background, 0, 0, 1200, 800);

  //Raumschiff-Auswahl // Spielanleitung -> Knöpfe
  rectMode(CENTER);
  fill(0);
  stroke(255);
  strokeWeight(5);
  rect(200, 650, 300, 120, 20);
  rect(1000, 650, 300, 120, 20);

  fill(255);
  textAlign(CENTER);
  textSize(40);
  textFont(ERAS);
  text("Raumschiff", 200, 640);
  text("Auswahl", 200, 690);
  text("Spielanleitung", 1000, 660);

  //Start-Knopf
  fill(196, 32, 32);
  rect(600, 720, 300, 80, 20);

  fill(255);
  textSize(50);
  text("START", 600, 740);

  //Kasten mit Spiel-Name
  fill(0);
  rect(600, 490, 1100, 140, 20);

  fill(255);
  textSize(100);
  text("Galaxy Hunter", 600, 520);

  //Erkennung Knopfdruck
  if (mousePressed) {
    if (mouseX > 450 && mouseX < 750 && mouseY > 680 && mouseY < 760 && delay_timer == 0) {
      println("start");
      clicksound.play();
      BGM.stop();
      start_music_game = true;
      game_started = true;
      main_menu = false;

      delay_timer = 15;
    }

    if (mouseX > 50 && mouseX < 350 && mouseY > 590 && mouseY < 710 && delay_timer == 0) {
      println("Auswahl");
      clicksound.play();
      ship_selection = true;
      main_menu = false;

      delay_timer = 15;
    }

    if (mouseX > 850 && mouseX < 1150 && mouseY > 590 && mouseY < 710 && delay_timer == 0) {
      println("Anleitung");
      clicksound.play();
      help_menu = true;
      main_menu = false;
      delay_timer = 15;
    }
  }
}

void spaceship_selection() {
  
  //Hintergrundbild
  imageMode(CORNER);
  image(Background, 0, 0, 1200, 800);

  //Grosses Anzeigefenster
  rectMode(CENTER);
  fill(0);
  stroke(255);
  strokeWeight(5);
  rect(600, 300, 800, 500, 20);

  //Knöpfe unten
  if (ShipNumber >= 1) {         //"Links-Knopf" bei erstem Schiff nicht anzeigen
    rect(450, 600, 60, 60, 10);
  }

  if (ShipNumber <= 1) {        //"Rechts-Knopf" bei erstem Schiff nicht anzeigen
    rect(750, 600, 60, 60, 10);
  }
  
  rect(600, 600, 200, 60, 10);

  //Schiff-Bild anzeigen
  imageMode(CENTER);
  image(Spaceships[ShipNumber], 600, 300, 460, 460);
  
  //Text auf Knöpfen
  fill(255);
  textAlign(CENTER, CENTER);

  textFont(ERAS);

  if (ShipNumber >= 1) {
    text("<", 450, 595);
  }

  if (ShipNumber <= 1) {
    text(">", 750, 595);
  }

  textSize(30);
  text("Auswählen", 600, 597);
  
  //Knopfdruck erkennen
  if (mousePressed) {
    if (mouseX > 420 && mouseX < 480 && mouseY > 570 && mouseY < 630 && delay_timer == 0 && ShipNumber > 0) {
      print("Links ");
      delay_timer = 15;
      ShipNumber--;
      clicksound.play();
    }

    if (mouseX > 720 && mouseX < 780 && mouseY > 570 && mouseY < 630 && delay_timer == 0 && ShipNumber < 2) {
      print("Rechts ");
      delay_timer = 15;
      clicksound.play();
      ShipNumber++;
    }

    if (mouseX > 500 && mouseX < 700 && mouseY > 570 && mouseY < 630 && delay_timer == 0) {
      print("Ausgewählt ");
      //delay_timer = 15;
      SelectedShipNumber = ShipNumber;
      main_menu = true;
      ship_selection = false;
      clicksound.play();
    }
  }
}

void game() {
  
  //Spielmusik starten
  if(start_music_game == true){
   playmusic_game();
   }
  
  //Cursor Status Prüfen
  if (game_paused == false) {
    cursor = false;
  } else {
    cursor = true;
  }
  
  imageMode(CORNER);
  rectMode(CORNER);
  noStroke();

  //Hintergrundbilder
  image(Background, XBackground, YBackground, 1200, 800);
  image(Background, XBackground, YBackground2, 1200, 800);
  YBackground+=Yspeed;
  YBackground2+=Yspeed;

  //Hintergrund verschieben wenn er aus dem Bild fliegt
  if (YBackground >= 800) {
    YBackground = -800;
  }

  if (YBackground2 >= 800) {
    YBackground2 = -800;
  }

  //Hintergrund verdunkeln mit schwarzem/transparentem rechteck (Bild wäre zu hell)
  fill(0, 0, 0, 150);
  rect(0, 0, 1200, 800);


  //Farbwechsel Fadenkreuz wenn Maus auf Asteroid ist
  if (mouseX > x && mouseX < x + 100 && mouseY > y && mouseY < y + 100 && game_mouse_movement == true) {
    crosshair = color(67, 206, 72);
  } else {
    crosshair = color(255, 0, 0);
  }


  //Klickerkennung auf Asteroid
  if (mousePressed) {
    if (mouseX > x && mouseX < x + 100 && mouseY > y && mouseY < y + 100 && game_mouse_movement == true) {
      shoot = true;
      LaserX = mouseX;
    }
  }

  //Schuss
  if (shoot == true) {
    if (sound_delay_timer == 0) {
      lasersound.play();
      sound_delay_timer = 5;
    }

    fill(255, 0, 0);
    rect(LaserX, LaserY, 3, 20);
    LaserY-=150;
    explosion = true;
  }

  //Explosion
  if (LaserY < y && explosion == true) {
    shoot = false;

    //Explosion
    image( Explosion[i%23], x - 50, y - 50, 200, 200);
    i++;

    moving = false;
    ETimer--;

    if (ETimer < 0) {                //Explosion-Timer --> Ohne Timer zu wenig "Zeit" bzw Durchgänge des Codeblocks um das GIF "abzuspielen"
      score ++;
      tempscore ++;
      LaserY = 700;
      x = random(100, 1100);
      y = -150;
      i = 0;
      moving = true;
      ETimer = 21;
      explosion = false;
    }
    
    //Level erhöhen wenn temporärer Score auf 10 ist -> dann temporären score wieder auf 0 setzen
    if (tempscore == 10) {
      level++;
      tempscore = 0;

      Yspeed+=4;
      YSpeed+=2;
    }
  }


  //Bewegung Asteroid 1
  if (moving == true) {
    image( Asteroid1[frameCount%19], x, y, 100, 100 );
    y+=YSpeed;
  }

  //Zielfernrohr sperren im pausemenu

  if (game_mouse_movement == true) {
    Xcrosshair = mouseX;
    Ycrosshair = mouseY;
  }

  //Zielfernrohr
  if (crosshair_visible == true) {
    stroke(255);
    strokeWeight(1);
    line(Xcrosshair - 50, Ycrosshair, Xcrosshair, Ycrosshair);
    line(Xcrosshair + 50, Ycrosshair, Xcrosshair, Ycrosshair);
    line(Xcrosshair, Ycrosshair - 50, Xcrosshair, Ycrosshair);
    line(Xcrosshair, Ycrosshair + 50, Xcrosshair, Ycrosshair);
    noFill();
    circle(Xcrosshair, Ycrosshair, 60);
    noStroke();
    fill(crosshair);
    circle(Xcrosshair, Ycrosshair, 10);
  }



  //Raumschiff
  if ( ship_visible == true) {
    image(Spaceships[SelectedShipNumber], Xcrosshair -100, 600, 200, 200);
  }

  //Score
  textAlign(CENTER, CENTER);
  fill(255);
  textFont(ERAS_2);
  text("Score: ", 1080, 50);
  text(score, 1150, 50);
  text("Level: ", 1080, 80);
  text(level, 1150, 80);

  //Spielende wenn Asteroid das Raumschiff trifft
  if (x > mouseX - 150 && x < mouseX + 60 && y > 550 && GameOver == false && game_mouse_movement == true) {
    crash = true;
  }

  if (crash == true) {

    if (xEndPos == 0) {
      xEndPos = mouseX - 200;
    }

    println("Game Over");

    //Gif explosion
    image( Explosion[i%23], xEndPos, 550, 400, 400);
    i++;

    ETimer--;

    //Nichts bewegt sich mehr
    game_mouse_movement = false;
    moving = false;
    crosshair_visible = false;

    if (ETimer < 10) {
      ship_visible = false;
    }

    if (ETimer < -1) {
      i = 0;
      GameOver = true;
      game_started = false;
    }
  }


  // Falls Asteroid aus dem Bild fliegt
  if (y > 900) {
    yEndPos = mouseY;
    xEndPos = mouseX;
    noCrashEnd = true;
    GameOver = true;
    game_started = false;
  }


  //Spiel pausieren
  if (keyPressed && key == 'p' && delay_timer == 0) {
    game_paused = true;
    delay_timer = 15;
  }
}

void GamePaused() {
  
  //Geschwindigkeit des Hintergrunds speichern während das Pausemenu offen ist 
  if (YSpeed != 0) {
    tempYSpeed = YSpeed;
    tempYspeed = Yspeed;
  }
  
  //Asteroid einfügen
  image( Asteroid1[frameCount%19], x, y, 100, 100 );
  
  //Rechteck Pausemenu
  rectMode(CENTER);
  fill(0);
  stroke(255);
  strokeWeight(8);
  rect(600, 400, 400, 300, 20);
  
  //Alles steht still während der Pause
  moving = false;
  YSpeed = 0;
  game_mouse_movement = false;
  
  //Knöpfe Pause-Menu
  fill(255);
  textSize(50);
  textAlign(CENTER, CENTER);
  text("Spiel pausiert", 600, 300);

  fill(0);
  stroke(255);
  strokeWeight(4);
  rect(600, 400, 300, 70, 10);

  stroke(229, 2, 2);
  rect(600, 490, 300, 70, 10);

  fill(255);
  textSize(30);
  text("Spiel fortsetzen", 600, 395);

  fill(229, 2, 2);
  text("Zum Hauptmenu", 600, 485);

  //Knopfdruck erkennen
  if (mousePressed && mouseButton == LEFT) {
    if (mouseX > 450 && mouseX < 750 && mouseY > 365 && mouseY < 435 && delay_timer == 0) {
      println("Fortsetzen");
      clicksound.play();
      delay_timer = 15;
      
      //Spiel läuft wieder
      game_paused = false;
      moving = true;
      Yspeed = tempYspeed;
      YSpeed = tempYSpeed;
      game_mouse_movement = true;
    }

    if (mouseX > 450 && mouseX < 750 && mouseY > 455 && mouseY < 525 && delay_timer == 0) {
      println("Verlassen");
      clicksound.play();
      delay_timer = 15;
      start_music = true;
      BGM_game.stop();
      
      //Alles zurücksetzen für nächste Runde
      y = -500;
      moving = true;
      Yspeed = 10;
      YSpeed = 20;
      game_mouse_movement = true;
      explosion = false;
      ETimer = 21;
      i = 0;
      score = 0;
      tempscore = 0;
      level = 0;

      main_menu = true;
      game_started = false;
      game_paused = false;
    }
  }
}


void help_menu() {
  //Hintergrundbild
  main_menu = false;
  background(0);
  imageMode(CORNER);
  image(Background, 0, 0, 1200, 800);
  
  //Knöpfe
  rectMode(CENTER);
  fill(0);
  stroke(255);
  strokeWeight(3);
  if (page_number >= 1) {             //"Links-Knopf" bei erstem Tutorial-Schritt nicht anzeigen
    rect(100, 300, 60, 150, 10);
  }
  if (page_number <= 4) {            //"Rechts-Knopf" bei letztem Tutorial-Schritt nicht anzeigen
    rect(1100, 300, 60, 150, 10);
  }

  textFont(ERAS);
  textAlign(CENTER, CENTER);
  fill(255);
  textSize(60);
  if (page_number >= 1) {          //"Links-Knopf Text" bei erstem Tutorial-Schritt nicht anzeigen
    text("<", 100, 295);
  }
  if (page_number <= 4) {            //"Rechts-Knopf Text" bei letztem Tutorial-Schritt nicht anzeigen
    text(">", 1100, 295);
  }
  
  //Fenster mit Tutorial Bild
  fill(0);
  stroke(255);
  strokeWeight(5);
  rect(600, 300, 800, 400, 20);

  imageMode(CENTER);
  image(Tutorial[page_number], 600, 300, 690, 390);

  strokeWeight(3);
  rect(600, 650, 1100, 150, 20);

  fill(255);
  textFont(ERAS_2);
  text(Tutorial_text[page_number], 600, 650);
  
  //Knopfdruck erkennen
  if (mousePressed) {
    if (mouseX > 70 && mouseX < 130 && mouseY > 225 && mouseY < 375 && delay_timer == 0 && page_number > 0) {
      print("Links ");
      delay_timer = 15;
      page_number--;
      clicksound.play();
    }

    if (mouseX > 1070 && mouseX < 1130 && mouseY > 225 && mouseY < 375 && delay_timer == 0 && page_number < 5) {
      print("Rechts ");
      delay_timer = 15;
      clicksound.play();
      page_number++;
    }
  }
  
  //Hauptmenu-Knopf anzeigen wenn das Tutorial fertig ist
  if (page_number == 5) {
    fill(0);
    rect(1100, 300, 150, 100, 10);

    fill(255);
    text("Zum", 1100, 285);
    text("Hauptmenu", 1100, 315);
    
    //Klickerkennung
    if (mousePressed) {
      if (mouseX > 1025 && mouseX < 1175 && mouseY > 250 && mouseY < 350 && delay_timer == 0) {
        //Zum Hauptmenu gehen
        print("Verlassen");
        page_number = 0;
        main_menu = true;
        help_menu = false;
        delay_timer = 15;
        clicksound.play();
      }
    }
  }
}

void game_over() {
  
  imageMode(CORNER);
  rectMode(CORNER);
  noStroke();

  //Hintergrundbilder
  image(Background, XBackground, YBackground, 1200, 800);
  image(Background, XBackground, YBackground2, 1200, 800);
  YBackground+=Yspeed;
  YBackground2+=Yspeed;

  //Hintergrund verschieben wenn er aus dem Bild fliegt
  if (YBackground >= 800) {
    YBackground = -800;
  }

  if (YBackground2 >= 800) {
    YBackground2 = -800;
  }
  if (opacity > 200) {
    Yspeed = 0;
  }

  fill(0, 0, 0, 150);
  rect(0, 0, 1200, 800);
  
  //Wenn Asteroid aus dem Bild fliegt bleibt das Raumschiff angezeigt, weil es ja nicht getroffen wurde
  if (noCrashEnd == true) {

    image(Spaceships[SelectedShipNumber], Xcrosshair -100, 600, 200, 200);
  }
  
  //Hintergrund wird langsam mit Rechteck überdeckt 
  opacity++;
  
  rectMode(CENTER);
  fill(0, 0, 0, opacity);
  rect(600, 400, 1200, 800);
  
  //Texte mit Score und Game Over einblenden
  fill(255, 0, 0, opacity - 60);
  textSize(150);
  textAlign(CENTER, CENTER);
  textFont(Stencil);
  text("GAME OVER", 600, 300);

  textSize(60);
  fill(255, 255, 255, opacity - 60);
  text("SCORE:", 600, 400);
  text(score, 600, 480);
  
  //Wenn die Opacity über 200 ist wird der "Zurück zum Hauptmenu"-Knopf angezeigt
  if(opacity > 200){
    
    cursor = true;
    
    //Knopf / Knopftext
    fill(0);
    stroke(255);
    strokeWeight(5);
    rect(600, 700, 400, 60, 10);
    
    fill(255);
    textFont(ERAS_2);
    textSize(20);
    text("Zum Hauptmenu", 600, 700);
    
    //Knopfdruck erkennen
    if (mousePressed) {
      if (mouseX > 400 && mouseX < 800 && mouseY > 670 && mouseY < 730 && delay_timer == 0) {
        print("Verlassen");
        main_menu = true;
        GameOver = false;
        game_started = false;
        delay_timer = 15;
        clicksound.play();
        
        //Spielmusik stoppen  / Hauptmenu-Musik starten
        BGM_game.stop();
        start_music = true;
        
        //Alles zurücksetzten für nächste Runde
        y = -500;
        moving = true;
        Yspeed = 10;
        YSpeed = 20;
        game_mouse_movement = true;
        opacity = 60;
        crash = false;
        noCrashEnd = false;
        crosshair_visible = true;
        ship_visible = true;
        xEndPos = 0;
        yEndPos = 0;
        explosion = false;
        ETimer = 21;
        i = 0;
        score = 0;
        tempscore = 0;
        level = 0;

      }
    }
    
  }
}

//Musik Abspielen im Hauptmenu
 void playmusic_mainmenu(){
 BGM.loop();
 start_music = false;
 }

 //Musik Abspielen im Spiel
 void playmusic_game(){
 BGM_game.loop();
 start_music_game = false;
 }
 
 
 /*
 Quellenverzeichnis des Verwendeten Bildmaterials / der verwendeten Musik:
 
 Bild Raumschiff 1: https://de.ldplayer.net/games/com-all-enemy-space-shooter-galaxy-attack-invaders-on-pc.html - zuletzt abgerufen am 23. 4. 2023
 Bild Raumschiff 2: https://www.turbosquid.com/de/3d-models/3d-fighter-03-cerberus-1805605 - zuletzt abgerufen am 23. 4. 2023
 Bild Raumschiff 3: https://www.cgtrader.com/3d-models/vehicle/sci-fi-vehicle/combat-space-ship - zuletzt abgerufen am 23. 4. 2023
 
 GIF Asteroid: https://gfycat.com/optimalsameguillemot - zuletzt abgerufen am 23. 4. 2023
 
 GIF Explosion: https://gifer.com/en/2eSc - zuletzt abgerufen am 23. 4. 2023
 
 Maussymbol Tutorial: https://apps.microsoft.com/store/detail/mousepointerreposition/9NCZ1P9HPWFH?hl=es-uy&gl=uy&cid=msft_web_chart - zuletzt abgerufen am 23. 4. 2023
 
 Bild Hintergrund: https://www.peakpx.com/en/hd-wallpaper-desktop-awntk - zuletzt abgerufen am 23. 4. 2023
 
 Hintergrundmusik Spiel: https://www.youtube.com/watch?v=m3zvVGJrTP8 - zuletzt abgerufen am 23. 4. 2023
 
 Hintergrundmusik Hauptmenu: https://www.youtube.com/watch?v=kpz8lpoLvrA - zuletzt abgerufen am 23. 4. 2023
 */
 
